
module.exports = {
    prepublish: 'Run BEFORE the package is packed and published, as well as on local npm install without any arguments.',
    prepare: 'Run both BEFORE the package is packed and published, on local npm install without any arguments, and when installing git dependencies. This is run AFTER prepublish, but BEFORE prepublishOnly.',
    prepublishOnly: 'Run BEFORE the package is prepared and packed, ONLY on npm publish.',
    prepack: 'run BEFORE a tarball is packed (on npm pack, npm publish, and when installing git dependencies)',
    postpack: 'Run AFTER the tarball has been generated and moved to its final destination.',
    publish:'Run AFTER the package is published.',
    postpublish: 'Run AFTER the package is published.',
    preinstall: 'Run BEFORE the package is installed',
    install: 'Run AFTER the package is installed.',
    postinstall: 'Run AFTER the package is installed.',
    preuninstall: 'Run BEFORE the package is uninstalled.',
    uninstall: 'Run BEFORE the package is uninstalled.',
    postuninstall: 'Run AFTER the package is uninstalled.',
    preversion: 'Run BEFORE bumping the package version.',
    version: 'Run AFTER bumping the package version, but BEFORE commit.',
    postversion: 'Run AFTER bumping the package version, and AFTER commit.',
    pretest:'Run by the npm test command.',
    test:'Run by the npm test command.',
    posttest: 'Run by the npm test command.',
    prestop:'Run by the npm stop command.',
    stop:'Run by the npm stop command.',
    poststop: 'Run by the npm stop command.',
    prestart:'Run by the npm start command.',
    start:'Run by the npm start command.',
    poststart: 'Run by the npm start command.',
    prerestart: 'Run by the npm restart command. Note: npm restart will run the stop and start scripts if no restart script is provided.',
    restart: 'Run by the npm restart command. Note: npm restart will run the stop and start scripts if no restart script is provided.',
    postrestart: 'Run by the npm restart command. Note: npm restart will run the stop and start scripts if no restart script is provided.',
    preshrinkwrap: 'Run by the npm shrinkwrap command.',
    shrinkwrap: 'Run by the npm shrinkwrap command. // 锁定发布的版本 : https://docs.npmjs.com/cli/shrinkwrap.html',
    postshrinkwrap: 'Run by the npm shrinkwrap command.'
}
